import { reactive as A, defineComponent as Vl, getCurrentInstance as Pl, ref as b, computed as O, onMounted as Bl, watchEffect as xl, toRefs as Sl, resolveComponent as g, resolveDirective as $e, openBlock as p, createBlock as v, normalizeStyle as Hl, unref as L, withCtx as n, createVNode as u, withDirectives as j, createElementVNode as se, renderSlot as H, withKeys as Ie, createElementBlock as M, Fragment as U, renderList as Z, mergeProps as w, createCommentVNode as $, vShow as Al, createTextVNode as N, toDisplayString as de, createSlots as Ke, resolveDynamicComponent as kl, normalizeProps as Ml, guardReactiveProps as Ul } from "vue";
import { ElNotification as Rl, ElMessage as Te, ElMessageBox as Ce } from "element-plus";
import { useRoute as Nl } from "vue-router";
const Q = {
  beforeSubmitHandler: "beforeSubmitHandler",
  beforedisabledHandler: "beforedisabledHandler",
  afterdisabledHandler: "afterdisabledHandler",
  beforeAddHandler: "beforeAddHandler",
  beforeEditHandler: "beforeEditHandler",
  beforeQueryHandler: "beforeQueryHandler",
  afterQueryHandler: "afterQueryHandler",
  beforeDeteleHandler: "beforeDeteleHandler",
  afterDeteleHandler: "afterDeteleHandler",
  beforeTableLazyHandler: "beforeTableLazyHandler"
};
function zl(s = { debug: !1 }) {
  const f = A({
    hooks: {}
  });
  return Object.keys(s).forEach((t) => {
    t !== "debug" && (f.hooks[t] = s[t]);
  }), {
    hookHandler: (t, x) => {
      let C = !1;
      try {
        s.debug && (console.group("DeBug\uFF1A", t), console.table(x.Data), console.groupEnd()), C = f.hooks[t](x);
      } catch {
        C = !0;
      }
      return C;
    }
  };
}
const te = (s, f = "success") => {
  Rl({
    title: s,
    type: f,
    offset: 70,
    duration: 2500
  });
};
function R(s) {
  let f;
  try {
    f = Array.isArray(s) ? [] : {}, s === null && (f = null);
  } catch {
    f = {};
  }
  for (const h in s)
    typeof s[h] == "object" ? f[h] = R(s[h]) : f[h] = s[h];
  return f;
}
function pe(s, f) {
  let h = R(s);
  for (var t in f)
    h.hasOwnProperty(t) && typeof f[t] == "object" ? h[t] = pe(h[t], f[t]) : h[t] = f[t];
  return h;
}
function Ol(s, f) {
  let h = {}, t = Object.getOwnPropertyNames(s), x = Object.getOwnPropertyNames(f);
  return t.length === x.length && t.forEach((C) => {
    s[C] !== f[C] && (h[C] = f[C]);
  }), h;
}
const $l = {
  debug: !1,
  IssearchForm: !1,
  labelWidth: 120,
  openIndex: !0,
  openMultipleSelection: !1,
  expand: !0,
  expandColumn: 4,
  menuWidth: 310,
  menuAlign: "left",
  dialogWidth: 800,
  editFooterButton: !0,
  fullscreen: !1,
  closeOnPressEscape: !0,
  destroyOnClosModal: !1,
  pageSizes: [10, 20, 50, 100],
  Pagination: {
    current: 1,
    pageSize: 10,
    total: 0
  },
  PaginationLayout: "->,total, sizes, prev, pager, next, jumper",
  hideOnSinglePage: !1,
  queryAfterMount: !1,
  apiName: {
    query: "query",
    add: "add",
    edit: "edit",
    delete: "delete",
    deleteFlag: "deleteFlag",
    remove: "remove"
  },
  permission: {
    add: "add",
    edit: "edit",
    delete: "delete",
    deleteFlag: "deleteFlag",
    remove: "remove"
  },
  permissions: ["add", "edit", "delete", "deleteFlag", "remove"]
};
let V = A({});
function I(...s) {
  V.debug && console.info("%c\u3010DeBug\u3011", "color:red", ...s);
}
const qe = (s) => {
  V = pe($l, s);
};
qe({});
const Il = /* @__PURE__ */ N(" \u65B0\u589E "), Kl = /* @__PURE__ */ N(" \u6279\u91CF\u5220\u9664 "), Tl = { class: "quick-search-area" }, ql = { style: { display: "flex", "justify-content": "flex-end" } }, Wl = /* @__PURE__ */ N("\u53D6\u6D88"), Ll = /* @__PURE__ */ N("\u91CD\u7F6E"), jl = /* @__PURE__ */ N("\u63D0\u4EA4"), Ql = /* @__PURE__ */ Vl({
  __name: "index",
  props: {
    url: null,
    source: null,
    rowKey: null,
    rowKeys: null,
    keyName: null,
    AddInitID: null,
    watchData: null,
    hooks: null,
    wrapperStyle: null,
    tableHeight: null,
    tableAttributes: null,
    editFooterButton: { type: Boolean, default: () => V.editFooterButton },
    queryAfterMount: { type: Boolean, default: () => V.queryAfterMount },
    permission: { default: () => V.permissions },
    IssearchForm: { type: Boolean, default: () => V.IssearchForm },
    openIndex: { type: Boolean },
    openMultipleSelection: { type: Boolean, default: () => V.openMultipleSelection },
    expand: { type: Boolean, default: () => V.expand },
    expandColumn: { default: () => V.expandColumn },
    dialogWidth: { default: () => V.dialogWidth },
    fullscreen: { type: Boolean },
    closeOnPressEscape: { type: Boolean },
    destroyOnClosModal: { type: Boolean, default: () => V.destroyOnClosModal },
    PaginationLayout: { default: () => V.PaginationLayout },
    hideOnSinglePage: { type: Boolean, default: () => V.hideOnSinglePage }
  },
  emits: ["update:modelValue", "cell-click", "row-contextmenu"],
  setup(s, { expose: f, emit: h }) {
    const t = s;
    I("\u521D\u59CB\u5316\u540E\u7684\u3010\u7CFB\u7EDF\u53C2\u6570\u3011", V), I("\u3010Props\u53C2\u6570\u3011", t);
    const x = Pl(), C = Nl(), k = b(), ce = b(), we = b(), ie = b(), J = b("add"), K = b(!1), ee = b(!1), z = b(!1), We = b(t.editFooterButton), i = A({ ...pe(V, t.source.options) }), { hookHandler: T } = zl(t.hooks);
    let q = O(() => i.CrudRequest);
    const D = b({ filter: {}, editor: {}, column: {} }), Le = b(), fe = b(), Ve = b(), ve = b(), Pe = b(), _ = b({}), je = b({}), y = b({}), be = b({}), G = b([]), Qe = b([]), P = A({
      current: i.Pagination.current,
      pageSize: i.Pagination.pageSize,
      total: i.Pagination.total
    }), X = b(0), ge = b(0), me = b(0), le = b(0);
    if ((() => {
      const { filter: l, editor: a, column: o, columns: c } = t.source;
      let F = {};
      l.forEach((E) => {
        c[E].searchDefaultValue !== void 0 ? F[E] = c[E].searchDefaultValue : F[E] = void 0, D.value.filter[E] = c[E];
      }), ve.value = R(F), _.value = R(ve.value);
      let Y = {};
      a.forEach((E) => {
        c[E].addDefaultValue !== void 0 ? Y[E] = c[E].addDefaultValue : Y[E] = void 0, D.value.editor[E] = c[E];
      }), Pe.value = R(Y), o.forEach((E) => {
        D.value.column[E] = c[E];
      }), Le.value = c;
    })(), C.params.data) {
      I("\u8DEF\u7531\u4F20\u53C2\uFF1A", C.params.data);
      let l = C.params.data, a = JSON.parse(l);
      _.value = pe(_.value, a), I("searchModel", _);
    }
    const Je = O(() => {
      let l = {};
      const a = ["el-input", "el-input-number", "el-select", "el-date-picker", "el-time-picker"];
      return t.source.filter.forEach((o) => {
        a.includes(D.value.filter[o].type) && (l[o] = D.value.filter[o]);
      }), l;
    }), Ge = O(() => {
      let l = {};
      const a = ["el-input", "el-input-number", "el-select", "el-date-picker", "el-time-picker", "el-cascader", "el-upload"];
      return t.source.editor.forEach((o) => {
        a.includes(D.value.editor[o].type) && W(D.value.editor[o], "visible") && (l[o] = D.value.editor[o]);
      }), l;
    }), Xe = O(() => ({ ...t.wrapperStyle })), Ye = O(() => (P.current - 1) * P.pageSize + 1), Ze = O(() => {
      const l = b(0);
      return t.tableHeight ? l.value = t.tableHeight : i.IssearchForm ? l.value = ge.value : l.value = me.value, l.value;
    }), Be = O(() => t.fullscreen ? le.value - 50 : le.value > 250 ? le.value - X.value * 0.3 : 250);
    Bl(() => {
      X.value = document.documentElement.clientHeight, k.value.style.display = "block", ge.value = X.value - 50 - 20 - 40 - 56 - ce.value.clientHeight - k.value.clientHeight, k.value.style.display = "none", me.value = X.value - 50 - 20 - 40 - 56 - ce.value.clientHeight, le.value = X.value - 54 - 62, t.queryAfterMount && B(), t.watchData && t.watchData.forEach((l) => {
        xl(() => {
          y.value[l.id] && (I("\u76D1\u542C\u7684id\u6570\u636E", y.value[l.id]), l.data.forEach((a) => {
            a.data[l.id] = y.value[l.id], I("\u76D1\u542C\u7684\u6570\u636E\u8BF7\u6C42", a), pl(a);
          }));
        });
      }), I("onMounted", m), I("Hight", { clientHeight: X, OpenSearchFormtableMaxHeight: ge, CloseSearchFormtableMaxHeight: me, EditFormMaxHeight: le });
    });
    const he = (l) => {
      let a = {};
      return t.rowKey && (a[t.rowKey] = l[t.rowKey]), t.rowKeys && t.rowKeys.forEach((o) => {
        a[o] = l[o];
      }), a;
    }, ue = (l) => l.formProps && l.formProps.type ? l.range ? l.formProps.type + "range" : l.formProps.type : "date", W = (l, a) => {
      if (a === "disabled")
        return typeof l.disabled == "function" ? l.disabled(m, J.value) : !1;
      if (a === "visible")
        return typeof l.visible == "function" ? l.visible(m, J.value) : !0;
    }, el = (l, a, o, c) => {
      h("cell-click", { row: l, column: a, cell: o, event: c });
    }, ll = (l, a, o, c) => {
      a.label && navigator.clipboard.writeText(o.innerText).then(() => {
        Te.success("\u590D\u5236\u6210\u529F\uFF01");
      });
    }, al = (l, a, o) => {
      h("row-contextmenu", { row: l, column: a, event: o }, m);
    }, ol = (l) => {
      G.value = l;
    }, nl = (l) => {
      let a = { ...l };
      return Object.keys(a).forEach((o) => {
        typeof a[o] == "function" && (a[o] = a[o].bind(this, m));
      }), a;
    }, tl = (l, a) => {
      let o = { ...l };
      return Object.keys(o).forEach((c) => {
        typeof o[c] == "function" && (o[c] = o[c].call(this, m, a));
      }), o;
    }, ul = (l) => {
      P.pageSize = l, B();
    }, rl = (l) => {
      P.current = l, P.current != null && B();
    }, sl = (l, a, o) => {
      if (a.type === "el-select") {
        const c = a.formProps.options.findIndex((F) => F.value == l.row[o]);
        return c === -1 ? l.row[o] : a.formProps.options[c].label;
      } else
        return l.row[o];
    }, dl = () => {
      re.value.length && re.value.forEach((l) => {
        D.value.editor[l].formProps.fileList = [];
      });
    }, re = O(() => {
      let l = [];
      for (const a in D.value.editor)
        if (Object.prototype.hasOwnProperty.call(D.value.editor, a)) {
          const o = D.value.editor[a];
          o.type === "el-upload" && o.formProps.hasOwnProperty("listType") && o.formProps.listType === "picture-card" && l.push(a);
        }
      return l;
    }), pl = (l) => {
      q.value({ url: l.url, name: l.name, data: l.data }).then((a) => {
        D.value.editor[l.key].formProps.options = a.data.map((o) => {
          if (typeof l.label == "string")
            return {
              value: o[l.value],
              label: o[l.label]
            };
          if (typeof l.label == "object")
            return {
              value: o[l.value],
              label: o[l.label[0]] + "--" + o[l.label[1]]
            };
        });
      });
    }, B = () => {
      ee.value = !0;
      const l = A({
        ..._.value
      });
      for (const a in l)
        Object.prototype.hasOwnProperty.call(l, a) && typeof l[a] == "string" && (l[a] = l[a].trim(), l[a] === "" && (l[a] = void 0));
      !T(Q.beforeQueryHandler, { CrudState: m, Data: l }) || q.value({
        url: t.url,
        name: i.apiName.query,
        data: {
          pagenum: P.current,
          pagesize: P.pageSize,
          ...l
        }
      }).then((a) => {
        const { data: o, page: c } = a;
        setTimeout(() => {
          cl(o, l), P.total = c.total, ee.value = !1;
        }, 50);
      }).catch(() => {
        ee.value = !1;
      });
    }, cl = (l, a) => {
      Object.keys(a).filter((c) => a[c] != null).length == 0 && (Ve.value = l), Ve.value = R(l), T(Q.afterQueryHandler, { CrudState: m, Data: l }) && (fe.value = R(l));
    }, xe = () => {
      _.value = R(ve.value), B();
    }, Se = (l) => {
      !l || (l.resetFields(), re.value.length && re.value.forEach((a) => {
        const o = a + "UploadRef";
        (x == null ? void 0 : x.refs[o])[0].clearFiles();
      }));
    }, He = () => {
      y.value = R(Pe.value);
      const l = A({ ...y.value });
      !T(Q.beforeAddHandler, { CrudState: m, Data: l }) || (J.value = "add", K.value = !0);
    }, ye = (l) => {
      const a = A({
        ...l
      });
      !T(Q.beforeEditHandler, { CrudState: m, Data: a }) || (Object.keys(a).forEach((o) => {
        y.value[o] = a[o], be.value[o] = a[o];
      }), J.value = "edit", K.value = !0);
    }, ae = async (l) => {
      !l || await l.validate((a) => {
        if (a) {
          const o = A({
            ...y.value
          });
          if (!T(Q.beforeSubmitHandler, { CrudState: m, Data: o }))
            return;
          m.Mode === "add" ? Ae(o) : ke(o);
        }
      });
    }, Ae = (l) => {
      z.value = !0;
      let a = l;
      l.FormData instanceof FormData && (a = l.FormData), q.value({ url: t.url, name: i.apiName.add, data: a }).then(() => {
        K.value = !1, te("\u65B0\u589E\u6210\u529F"), B(), z.value = !1;
      }).catch(() => {
        z.value = !1;
      });
    }, ke = (l) => {
      z.value = !0;
      let a = l;
      if (l.FormData instanceof FormData)
        a = l.FormData;
      else {
        const o = Ol(be.value, a);
        if (JSON.stringify(o) === "{}")
          return z.value = !1, Te({ message: "\u6CA1\u6709\u63D0\u4EA4\u9879\uFF01", grouping: !0 });
        a = {
          ...he(l),
          ...o
        };
      }
      q.value({ url: t.url, name: i.apiName.edit, data: a }).then(() => {
        K.value = !1, te("\u4FEE\u6539\u6210\u529F"), B(), z.value = !1;
      }).catch(() => {
        z.value = !1;
      });
    }, _e = (l) => {
      Ce.confirm(`\u786E\u5B9A\u8981 \u201C${l.deleteFlag ? "\u542F\u7528" : "\u7981\u7528"}\u201D \u8BE5\u6761\u6570\u636E\u5417\uFF1F`, "\u63D0\u793A", {
        confirmButtonText: "\u786E\u5B9A",
        cancelButtonText: "\u53D6\u6D88",
        type: "warning"
      }).then(() => {
        const a = A({
          row: { ...l },
          ...he(l),
          deleteFlag: l.deleteFlag == 0 ? 1 : 0
        });
        !T(Q.beforedisabledHandler, { CrudState: m, Data: a }) || q.value({
          url: t.url,
          name: i.apiName.deleteFlag,
          data: a
        }).then(() => {
          te(`\u6570\u636E${l.deleteFlag ? "\u542F\u7528" : "\u7981\u7528"}\u6210\u529F`), B();
        });
      }).catch(() => {
      });
    }, Fe = (l) => {
      Ce.confirm("\u786E\u5B9A\u8981\u5220\u9664\u672C\u6761\u6570\u636E\u5417\uFF1F", "\u63D0\u793A", {
        confirmButtonText: "\u786E\u5B9A",
        cancelButtonText: "\u53D6\u6D88",
        type: "warning"
      }).then(() => {
        const a = A({
          row: { ...l },
          ...he(l)
        });
        !T(Q.beforeDeteleHandler, { CrudState: m, Data: a }) || q.value({
          url: t.url,
          name: i.apiName.delete,
          data: a
        }).then(() => {
          te("\u5220\u9664\u6210\u529F"), B();
        });
      }).catch(() => {
      });
    }, Me = () => {
      Ce.confirm("\u786E\u5B9A\u8981\u5220\u9664\u8FD9\u51E0\u6761\u6570\u636E\u5417\uFF1F", "\u63D0\u793A", {
        confirmButtonText: "\u786E\u5B9A",
        cancelButtonText: "\u53D6\u6D88",
        type: "warning"
      }).then(() => {
        const l = G.value.map((a) => a[t.rowKey]);
        q.value({
          url: t.url,
          name: i.apiName.remove,
          data: { [t.rowKey]: l, selection: G.value }
        }).then(() => {
          te("\u6279\u91CF\u5220\u9664\u6210\u529F"), G.value = [], we.value.clearSelection(), B();
        });
      }).catch(() => {
      });
    }, m = A({
      ElementArrs: D,
      tableData: fe,
      multipleSelection: G,
      searchModel: _,
      searchFormValue: je,
      editModel: y,
      editFormValue: be,
      uploadFiles: Qe,
      tableLoading: ee,
      Pagination: P,
      Mode: J,
      queryRecord: B,
      refresh: xe,
      resetForm: Se,
      addRecord: He,
      editRecord: ye,
      handleSubmit: ae,
      handleAdd: Ae,
      handleEdit: ke,
      delFlag: _e,
      deleteRecord: Fe,
      deleteMulRecord: Me
    });
    return f({
      ...Sl(m)
    }), (l, a) => {
      const o = g("el-input"), c = g("el-form-item"), F = g("el-col"), Y = g("el-input-number"), E = g("el-option"), Ue = g("el-select"), Ee = g("el-date-picker"), Re = g("el-time-picker"), Ne = g("el-row"), ze = g("el-form"), il = g("el-collapse-transition"), S = g("el-button"), fl = g("el-empty"), oe = g("el-table-column"), vl = g("el-descriptions-item"), bl = g("el-descriptions"), gl = g("el-button-group"), ml = g("el-table"), hl = g("el-pagination"), yl = g("el-cascader"), _l = g("plus"), Fl = g("el-icon"), El = g("el-upload"), Cl = g("el-scrollbar"), Oe = g("el-card"), Dl = g("el-dialog"), ne = $e("permission"), wl = $e("loading");
      return p(), v(Oe, {
        style: Hl([{ border: "0" }, L(Xe)])
      }, {
        default: n(() => [
          u(il, null, {
            default: n(() => [
              j(se("div", {
                id: "plain",
                ref_key: "searchFormRef",
                ref: k
              }, [
                H(l.$slots, "search-form", {
                  editModel: _.value,
                  queryRecord: B,
                  CrudState: m
                }, void 0, !0),
                u(ze, {
                  model: _.value,
                  "label-width": i.labelWidth,
                  onKeyup: Ie(B, ["enter", "native"])
                }, {
                  default: n(() => [
                    u(Ne, null, {
                      default: n(() => [
                        H(l.$slots, "search-form-top", { CrudState: m }, void 0, !0),
                        (p(!0), M(U, null, Z(L(Je), (e, r) => (p(), M(U, null, [
                          e.type === "el-input" ? (p(), v(F, {
                            key: 0,
                            xs: e.span && e.span.xs ? e.span.xs : 12,
                            sm: e.span && e.span.sm ? e.span.sm : 12,
                            md: e.span && e.span.md ? e.span.md : 12,
                            lg: e.span && e.span.lg ? e.span.lg : 6
                          }, {
                            default: n(() => [
                              u(c, {
                                label: e.label
                              }, {
                                default: n(() => [
                                  u(o, w({
                                    style: { width: "100%" },
                                    modelValue: _.value[r],
                                    "onUpdate:modelValue": (d) => _.value[r] = d,
                                    clearable: "",
                                    placeholder: "\u6A21\u7CCA\u67E5\u627E"
                                  }, e.formProps), null, 16, ["modelValue", "onUpdate:modelValue"])
                                ]),
                                _: 2
                              }, 1032, ["label"])
                            ]),
                            _: 2
                          }, 1032, ["xs", "sm", "md", "lg"])) : e.type === "el-input-number" ? (p(), v(F, {
                            key: 1,
                            xs: e.span && e.span.xs ? e.span.xs : 12,
                            sm: e.span && e.span.sm ? e.span.sm : 12,
                            md: e.span && e.span.md ? e.span.md : 12,
                            lg: e.span && e.span.lg ? e.span.lg : 6
                          }, {
                            default: n(() => [
                              u(c, {
                                label: e.label
                              }, {
                                default: n(() => [
                                  u(Y, w({
                                    style: { width: "100%" },
                                    modelValue: _.value[r],
                                    "onUpdate:modelValue": (d) => _.value[r] = d,
                                    placeholder: "\u8BF7\u8F93\u5165"
                                  }, e.formProps), null, 16, ["modelValue", "onUpdate:modelValue"])
                                ]),
                                _: 2
                              }, 1032, ["label"])
                            ]),
                            _: 2
                          }, 1032, ["xs", "sm", "md", "lg"])) : e.type === "el-select" ? (p(), v(F, {
                            key: 2,
                            xs: e.span && e.span.xs ? e.span.xs : 12,
                            sm: e.span && e.span.sm ? e.span.sm : 12,
                            md: e.span && e.span.md ? e.span.md : 12,
                            lg: e.span && e.span.lg ? e.span.lg : 6
                          }, {
                            default: n(() => [
                              u(c, {
                                label: e.label
                              }, {
                                default: n(() => [
                                  u(Ue, w({
                                    style: { width: "100%" },
                                    modelValue: _.value[r],
                                    "onUpdate:modelValue": (d) => _.value[r] = d,
                                    clearable: "",
                                    placeholder: "\u8BF7\u9009\u62E9"
                                  }, e.formProps), {
                                    default: n(() => [
                                      (p(!0), M(U, null, Z(e.formProps.options, (d) => (p(), v(E, {
                                        key: d.value,
                                        label: d.label,
                                        value: d.value
                                      }, null, 8, ["label", "value"]))), 128))
                                    ]),
                                    _: 2
                                  }, 1040, ["modelValue", "onUpdate:modelValue"])
                                ]),
                                _: 2
                              }, 1032, ["label"])
                            ]),
                            _: 2
                          }, 1032, ["xs", "sm", "md", "lg"])) : e.type === "el-date-picker" && ue(e).includes("range") ? (p(), v(F, {
                            key: 3,
                            xs: e.span && e.span.xs ? e.span.xs : 12,
                            sm: e.span && e.span.sm ? e.span.sm : 12,
                            md: e.span && e.span.md ? e.span.md : 12,
                            lg: e.span && e.span.lg ? e.span.lg : 12
                          }, {
                            default: n(() => [
                              u(c, {
                                label: e.label
                              }, {
                                default: n(() => [
                                  u(Ee, w({
                                    style: { width: "100%" },
                                    modelValue: _.value[r],
                                    "onUpdate:modelValue": (d) => _.value[r] = d,
                                    "start-placeholder": "\u8D77\u59CB",
                                    "range-separator": "\u81F3",
                                    "end-placeholder": "\u7ED3\u675F",
                                    placeholder: "\u8BF7\u9009\u62E9",
                                    clearable: ""
                                  }, e.formProps, {
                                    type: ue(e)
                                  }), null, 16, ["modelValue", "onUpdate:modelValue", "type"])
                                ]),
                                _: 2
                              }, 1032, ["label"])
                            ]),
                            _: 2
                          }, 1032, ["xs", "sm", "md", "lg"])) : e.type === "el-date-picker" && ue(e) ? (p(), v(F, {
                            key: 4,
                            xs: e.span && e.span.xs ? e.span.xs : 12,
                            sm: e.span && e.span.sm ? e.span.sm : 12,
                            md: e.span && e.span.md ? e.span.md : 12,
                            lg: e.span && e.span.lg ? e.span.lg : 6
                          }, {
                            default: n(() => [
                              u(c, {
                                label: e.label
                              }, {
                                default: n(() => [
                                  u(Ee, w({
                                    style: { width: "100%" },
                                    modelValue: _.value[r],
                                    "onUpdate:modelValue": (d) => _.value[r] = d,
                                    "start-placeholder": "\u8D77\u59CB",
                                    "range-separator": "\u81F3",
                                    "end-placeholder": "\u7ED3\u675F",
                                    placeholder: "\u8BF7\u9009\u62E9",
                                    clearable: ""
                                  }, e.formProps, {
                                    type: ue(e)
                                  }), null, 16, ["modelValue", "onUpdate:modelValue", "type"])
                                ]),
                                _: 2
                              }, 1032, ["label"])
                            ]),
                            _: 2
                          }, 1032, ["xs", "sm", "md", "lg"])) : e.type === "el-time-picker" ? (p(), v(F, {
                            key: 5,
                            xs: e.span && e.span.xs ? e.span.xs : 12,
                            sm: e.span && e.span.sm ? e.span.sm : 12,
                            md: e.span && e.span.md ? e.span.md : 12,
                            lg: e.span && e.span.lg ? e.span.lg : 6
                          }, {
                            default: n(() => [
                              u(c, {
                                label: e.label
                              }, {
                                default: n(() => [
                                  u(Re, w({
                                    style: { width: "100%" },
                                    modelValue: _.value[r],
                                    "onUpdate:modelValue": (d) => _.value[r] = d,
                                    "start-placeholder": "\u8D77\u59CB",
                                    "range-separator": "\u81F3",
                                    "end-placeholder": "\u7ED3\u675F",
                                    placeholder: "\u8BF7\u9009\u62E9",
                                    clearable: ""
                                  }, e.formProps, {
                                    "is-range": e.range
                                  }), null, 16, ["modelValue", "onUpdate:modelValue", "is-range"])
                                ]),
                                _: 2
                              }, 1032, ["label"])
                            ]),
                            _: 2
                          }, 1032, ["xs", "sm", "md", "lg"])) : $("", !0)
                        ], 64))), 256)),
                        H(l.$slots, "search-form-bottom", { CrudState: m }, void 0, !0)
                      ]),
                      _: 3
                    })
                  ]),
                  _: 3
                }, 8, ["model", "label-width", "onKeyup"])
              ], 512), [
                [Al, i.IssearchForm]
              ])
            ]),
            _: 3
          }),
          se("div", {
            ref_key: "buttonAreaRef",
            ref: ce,
            class: "button_area"
          }, [
            j((p(), v(S, {
              type: "primary",
              icon: "plus",
              onClick: He
            }, {
              default: n(() => [
                Il
              ]),
              _: 1
            })), [
              [ne, { permission: s.permission, access: [i.permission.add] }]
            ]),
            i.openMultipleSelection ? j((p(), v(S, {
              key: 0,
              disabled: G.value.length <= 0,
              type: "danger",
              icon: "delete",
              onClick: Me
            }, {
              default: n(() => [
                Kl
              ]),
              _: 1
            }, 8, ["disabled"])), [
              [ne, { permission: s.permission, access: [i.permission.remove] }]
            ]) : $("", !0),
            H(l.$slots, "button-area", { CrudState: m }, void 0, !0)
          ], 512),
          j((p(), v(ml, w({
            ref_key: "tableRef",
            ref: we,
            data: fe.value,
            "row-key": s.rowKey,
            height: L(Ze),
            onCellClick: el,
            onCellDblclick: ll,
            onRowContextmenu: al,
            onSelectionChange: ol
          }, s.tableAttributes), {
            empty: n(() => [
              u(fl, {
                "image-size": 80,
                description: "\u6682\u65E0\u6570\u636E"
              })
            ]),
            default: n(() => [
              s.openMultipleSelection ? (p(), v(oe, {
                key: 0,
                type: "selection",
                "reserve-selection": "",
                width: 44
              })) : $("", !0),
              i.expand ? (p(), v(oe, {
                key: 1,
                type: "expand",
                width: 55
              }, {
                default: n((e) => [
                  u(bl, {
                    column: i.expandColumn,
                    border: ""
                  }, {
                    default: n(() => [
                      (p(!0), M(U, null, Z(s.source.columns, (r, d) => (p(), M(U, { key: d }, [
                        r.hidden ? $("", !0) : (p(), v(vl, {
                          key: 0,
                          label: r.label
                        }, {
                          default: n(() => [
                            N(de(sl(e, r, d)), 1)
                          ]),
                          _: 2
                        }, 1032, ["label"]))
                      ], 64))), 128))
                    ]),
                    _: 2
                  }, 1032, ["column"])
                ]),
                _: 1
              })) : $("", !0),
              i.openIndex ? (p(), v(oe, {
                key: 2,
                label: "###",
                width: 55,
                "show-overflow-tooltip": ""
              }, {
                default: n(({ row: e, column: r, $index: d }) => [
                  N(de(L(Ye) + d), 1)
                ]),
                _: 1
              })) : $("", !0),
              (p(!0), M(U, null, Z(D.value.column, (e, r) => (p(), v(oe, w({
                key: r,
                align: e.align || "left"
              }, e.tableProps, {
                label: e.label,
                prop: r,
                "show-overflow-tooltip": ""
              }), Ke({ _: 2 }, [
                e.columnSlot ? {
                  name: "default",
                  fn: n((d) => [
                    (p(), v(kl(e.columnSlot.is), Ml(Ul(tl(e.columnSlot, d))), null, 16))
                  ])
                } : void 0
              ]), 1040, ["align", "label", "prop"]))), 128)),
              H(l.$slots, "default", {}, void 0, !0),
              u(oe, {
                align: i.menuAlign || "left",
                width: t.keyName ? i.menuWidth : i.menuWidth - 150
              }, {
                header: n(() => [
                  se("div", Tl, [
                    t.keyName ? (p(), v(o, {
                      key: 0,
                      style: { width: "150px" },
                      modelValue: _.value[t.keyName],
                      "onUpdate:modelValue": a[0] || (a[0] = (e) => _.value[t.keyName] = e),
                      placeholder: D.value.filter[t.keyName].label + "\u6A21\u7CCA\u67E5\u627E",
                      clearable: "",
                      onKeyup: Ie(B, ["enter", "native"])
                    }, null, 8, ["modelValue", "placeholder", "onKeyup"])) : $("", !0),
                    u(gl, null, {
                      default: n(() => [
                        u(S, {
                          color: "#67c23a",
                          icon: "search",
                          onClick: B
                        }),
                        u(S, {
                          color: "#e6a23c",
                          icon: "refresh",
                          onClick: xe
                        }),
                        u(S, {
                          color: "#409eff",
                          icon: "expand",
                          onClick: a[1] || (a[1] = (e) => i.IssearchForm = !i.IssearchForm)
                        })
                      ]),
                      _: 1
                    })
                  ])
                ]),
                default: n((e) => [
                  H(l.$slots, "menu-top", {
                    scope: e,
                    delFlag: _e,
                    editRecord: ye,
                    deleteRecord: Fe,
                    CrudState: m
                  }, void 0, !0),
                  j((p(), v(S, {
                    plain: "",
                    type: e.row.deleteFlag ? "danger" : "success",
                    onClick: (r) => _e(e.row)
                  }, {
                    default: n(() => [
                      N(de(e.row.deleteFlag ? "\u7981\u7528" : "\u542F\u7528"), 1)
                    ]),
                    _: 2
                  }, 1032, ["type", "onClick"])), [
                    [ne, { permission: s.permission, access: [i.permission.deleteFlag] }]
                  ]),
                  j(u(S, {
                    plain: "",
                    type: "primary",
                    icon: "edit",
                    onClick: (r) => ye(e.row)
                  }, null, 8, ["onClick"]), [
                    [ne, { permission: s.permission, access: [i.permission.edit] }]
                  ]),
                  j(u(S, {
                    type: "danger",
                    icon: "delete",
                    onClick: (r) => Fe(e.row)
                  }, null, 8, ["onClick"]), [
                    [ne, { permission: s.permission, access: [i.permission.delete] }]
                  ]),
                  H(l.$slots, "menu-bottom", {
                    scope: e,
                    CrudState: m
                  }, void 0, !0)
                ]),
                _: 3
              }, 8, ["align", "width"])
            ]),
            _: 3
          }, 16, ["data", "row-key", "height"])), [
            [wl, ee.value]
          ]),
          u(hl, {
            style: { "margin-top": "20px" },
            "hide-on-single-page": i.hideOnSinglePage,
            currentPage: P.current,
            "onUpdate:currentPage": a[2] || (a[2] = (e) => P.current = e),
            "page-size": P.pageSize,
            "onUpdate:page-size": a[3] || (a[3] = (e) => P.pageSize = e),
            "page-sizes": i.pageSizes,
            background: "",
            layout: i.PaginationLayout,
            total: P.total,
            onSizeChange: ul,
            onCurrentChange: rl
          }, null, 8, ["hide-on-single-page", "currentPage", "page-size", "page-sizes", "layout", "total"]),
          u(Dl, {
            "custom-class": "DialogVisible",
            ref: "dialogRef",
            modelValue: K.value,
            "onUpdate:modelValue": a[7] || (a[7] = (e) => K.value = e),
            title: J.value === "add" ? "\u65B0\u589E" : "\u4FEE\u6539",
            width: i.dialogWidth,
            "destroy-on-close": "",
            "close-on-press-escape": i.closeOnPressEscape,
            fullscreen: i.fullscreen,
            "close-on-click-modal": i.destroyOnClosModal,
            onClosed: dl
          }, Ke({
            default: n(() => [
              u(Oe, {
                class: "edit-form-card",
                shadow: "never"
              }, {
                default: n(() => [
                  u(Cl, {
                    height: L(Be),
                    "max-height": L(Be)
                  }, {
                    default: n(() => [
                      H(l.$slots, "edit-form", {
                        editModel: y.value,
                        handleSubmit: ae,
                        CrudState: m
                      }, void 0, !0),
                      u(ze, {
                        id: "DialogVisible-edit-form",
                        class: "edit-form",
                        ref_key: "editFormRef",
                        ref: ie,
                        model: y.value,
                        "label-width": i.labelWidth
                      }, {
                        default: n(() => [
                          u(Ne, null, {
                            default: n(() => [
                              H(l.$slots, "edit-form-top", {
                                editModel: y.value,
                                handleSubmit: ae,
                                CrudState: m
                              }, void 0, !0),
                              (p(!0), M(U, null, Z(L(Ge), (e, r) => (p(), M(U, { key: r }, [
                                e.type === "el-input" ? (p(), v(F, {
                                  key: 0,
                                  span: e.span ? e.span.span : 24
                                }, {
                                  default: n(() => [
                                    u(c, {
                                      label: e.label,
                                      prop: r,
                                      rules: e.rules
                                    }, {
                                      default: n(() => [
                                        u(o, w({
                                          style: { width: "100%" },
                                          modelValue: y.value[r],
                                          "onUpdate:modelValue": (d) => y.value[r] = d,
                                          clearable: "",
                                          placeholder: "\u8BF7\u8F93\u5165",
                                          disabled: W(e, "disabled")
                                        }, e.formProps), null, 16, ["modelValue", "onUpdate:modelValue", "disabled"])
                                      ]),
                                      _: 2
                                    }, 1032, ["label", "prop", "rules"])
                                  ]),
                                  _: 2
                                }, 1032, ["span"])) : e.type === "el-input-number" ? (p(), v(F, {
                                  key: 1,
                                  span: e.span ? e.span.span : 24
                                }, {
                                  default: n(() => [
                                    u(c, {
                                      label: e.label,
                                      prop: r,
                                      rules: e.rules
                                    }, {
                                      default: n(() => [
                                        u(Y, w({
                                          style: { width: "100%" },
                                          modelValue: y.value[r],
                                          "onUpdate:modelValue": (d) => y.value[r] = d,
                                          clearable: "",
                                          placeholder: "\u8BF7\u8F93\u5165",
                                          disabled: W(e, "disabled")
                                        }, e.formProps), null, 16, ["modelValue", "onUpdate:modelValue", "disabled"])
                                      ]),
                                      _: 2
                                    }, 1032, ["label", "prop", "rules"])
                                  ]),
                                  _: 2
                                }, 1032, ["span"])) : e.type === "el-select" ? (p(), v(F, {
                                  key: 2,
                                  span: e.span ? e.span.span : 24
                                }, {
                                  default: n(() => [
                                    u(c, {
                                      label: e.label,
                                      prop: r,
                                      rules: e.rules
                                    }, {
                                      default: n(() => [
                                        u(Ue, w({
                                          style: { width: "100%" },
                                          modelValue: y.value[r],
                                          "onUpdate:modelValue": (d) => y.value[r] = d,
                                          clearable: "",
                                          placeholder: "\u8BF7\u9009\u62E9",
                                          disabled: W(e, "disabled")
                                        }, e.formProps), {
                                          default: n(() => [
                                            (p(!0), M(U, null, Z(e.formProps.options, (d) => (p(), v(E, {
                                              key: d.value,
                                              label: d.label,
                                              value: d.value
                                            }, null, 8, ["label", "value"]))), 128))
                                          ]),
                                          _: 2
                                        }, 1040, ["modelValue", "onUpdate:modelValue", "disabled"])
                                      ]),
                                      _: 2
                                    }, 1032, ["label", "prop", "rules"])
                                  ]),
                                  _: 2
                                }, 1032, ["span"])) : e.type === "el-date-picker" ? (p(), v(F, {
                                  key: 3,
                                  span: e.span ? e.span.span : 24
                                }, {
                                  default: n(() => [
                                    u(c, {
                                      label: e.label,
                                      prop: r,
                                      rules: e.rules
                                    }, {
                                      default: n(() => [
                                        u(Ee, w({
                                          style: { width: "100%" },
                                          modelValue: y.value[r],
                                          "onUpdate:modelValue": (d) => y.value[r] = d,
                                          clearable: "",
                                          placeholder: "\u8BF7\u9009\u62E9",
                                          disabled: W(e, "disabled")
                                        }, e.formProps), null, 16, ["modelValue", "onUpdate:modelValue", "disabled"])
                                      ]),
                                      _: 2
                                    }, 1032, ["label", "prop", "rules"])
                                  ]),
                                  _: 2
                                }, 1032, ["span"])) : e.type === "el-time-picker" ? (p(), v(F, {
                                  key: 4,
                                  span: e.span ? e.span.span : 24
                                }, {
                                  default: n(() => [
                                    u(c, {
                                      label: e.label,
                                      prop: r,
                                      rules: e.rules
                                    }, {
                                      default: n(() => [
                                        u(Re, w({
                                          style: { width: "100%" },
                                          modelValue: y.value[r],
                                          "onUpdate:modelValue": (d) => y.value[r] = d,
                                          clearable: "",
                                          "start-placeholder": "\u8D77\u59CB",
                                          "range-separator": "\u81F3",
                                          "end-placeholder": "\u7ED3\u675F",
                                          placeholder: "\u8BF7\u9009\u62E9",
                                          disabled: W(e, "disabled")
                                        }, e.formProps), null, 16, ["modelValue", "onUpdate:modelValue", "disabled"])
                                      ]),
                                      _: 2
                                    }, 1032, ["label", "prop", "rules"])
                                  ]),
                                  _: 2
                                }, 1032, ["span"])) : e.type === "el-cascader" ? (p(), v(F, {
                                  key: 5,
                                  span: e.span ? e.span.span : 24
                                }, {
                                  default: n(() => [
                                    u(c, {
                                      label: e.label,
                                      prop: r,
                                      rules: e.rules
                                    }, {
                                      default: n(() => [
                                        u(yl, w({
                                          style: { width: "100%" },
                                          modelValue: y.value[r],
                                          "onUpdate:modelValue": (d) => y.value[r] = d,
                                          props: e.formProps.props,
                                          placeholder: "\u8BF7\u9009\u62E9",
                                          "show-all-levels": !1,
                                          disabled: W(e, "disabled")
                                        }, e.formProps), null, 16, ["modelValue", "onUpdate:modelValue", "props", "disabled"])
                                      ]),
                                      _: 2
                                    }, 1032, ["label", "prop", "rules"])
                                  ]),
                                  _: 2
                                }, 1032, ["span"])) : e.type === "el-upload" ? (p(), v(F, {
                                  key: 6,
                                  span: e.span ? e.span.span : 24
                                }, {
                                  default: n(() => [
                                    u(c, {
                                      label: e.label,
                                      prop: r,
                                      rules: e.rules
                                    }, {
                                      default: n(() => [
                                        u(El, w({
                                          style: { width: "100%" },
                                          ref_for: !0,
                                          ref: r + "UploadRef",
                                          action: ""
                                        }, nl(e.formProps)), {
                                          default: n(() => [
                                            e.formProps.listType !== "picture-card" ? (p(), v(S, {
                                              key: 0,
                                              type: "primary"
                                            }, {
                                              default: n(() => [
                                                N(de(e.formProps.butName || "\u9009\u62E9\u6587\u4EF6"), 1)
                                              ]),
                                              _: 2
                                            }, 1024)) : (p(), v(Fl, { key: 1 }, {
                                              default: n(() => [
                                                u(_l)
                                              ]),
                                              _: 1
                                            }))
                                          ]),
                                          _: 2
                                        }, 1040)
                                      ]),
                                      _: 2
                                    }, 1032, ["label", "prop", "rules"])
                                  ]),
                                  _: 2
                                }, 1032, ["span"])) : $("", !0)
                              ], 64))), 128)),
                              H(l.$slots, "edit-form-bottom", {
                                editModel: y.value,
                                handleSubmit: ae,
                                CrudState: m
                              }, void 0, !0)
                            ]),
                            _: 3
                          })
                        ]),
                        _: 3
                      }, 8, ["model", "label-width"])
                    ]),
                    _: 3
                  }, 8, ["height", "max-height"])
                ]),
                _: 3
              })
            ]),
            _: 2
          }, [
            We.value ? {
              name: "footer",
              fn: n(() => [
                se("div", ql, [
                  H(l.$slots, "edit-form-footer", { CrudState: m }, void 0, !0),
                  u(S, {
                    onClick: a[4] || (a[4] = (e) => K.value = !1)
                  }, {
                    default: n(() => [
                      Wl
                    ]),
                    _: 1
                  }),
                  u(S, {
                    type: "warning",
                    plain: "",
                    onClick: a[5] || (a[5] = (e) => Se(ie.value))
                  }, {
                    default: n(() => [
                      Ll
                    ]),
                    _: 1
                  }),
                  u(S, {
                    type: "primary",
                    loading: z.value,
                    onClick: a[6] || (a[6] = (e) => ae(ie.value))
                  }, {
                    default: n(() => [
                      jl
                    ]),
                    _: 1
                  }, 8, ["loading"])
                ])
              ])
            } : void 0
          ]), 1032, ["modelValue", "title", "width", "close-on-press-escape", "fullscreen", "close-on-click-modal"])
        ]),
        _: 3
      }, 8, ["style"]);
    };
  }
});
const Jl = (s, f) => {
  const h = s.__vccOpts || s;
  for (const [t, x] of f)
    h[t] = x;
  return h;
}, De = /* @__PURE__ */ Jl(Ql, [["__scopeId", "data-v-bc157726"]]), Gl = {
  mounted(s, f, h) {
    const t = f.value.permission, x = f.value.access;
    let C = !1;
    for (let k = 0; k < x.length; k++)
      if (t.includes(x[k])) {
        C = !0;
        break;
      } else
        C = !1;
    C || s.parentNode && s.parentNode.removeChild(s);
  }
};
De.install = (s) => {
  s.component("CrudEl", De), s.directive("permission", Gl);
};
const ea = (s, f) => {
  f ? (f.CrudRequest || console.error("\u8BF7\u914D\u7F6E\u5168\u5C40\u8BF7\u6C42\u7684\u4E3B\u65B9\u6CD5\uFF1ACrudRequest"), qe(f), s.use(De)) : console.error("\u8BF7\u521D\u59CB\u5316CrudEl\u914D\u7F6E\u9879");
};
export {
  pe as DataMerger,
  R as DeepClone,
  qe as InitSys,
  ea as createCrudEl,
  Q as hooksName,
  Ol as isObjEqual,
  zl as useHooks
};
